import { world } from 'mojang-minecraft';
world.events.tick.subscribe(() => {
  function runCommand(command, dimension) {
    try {
      return { error: false, ...world.getDimension(dimension ?? 'overworld').runCommand(command)};
    } catch (error) {
      return { error: true };
    };
  };

  function getPlayers() {
    let data = [];
    data = runCommand(`list`).players.split(', ');
    return data;
  };

  function lookForItem(itemIdentifier) {
    const data = runCommand(`clear @a ${itemIdentifier} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier.split(":")[1]}"`);
    };
  };

  function lookForItem2(itemIdentifier2) {
    const data = runCommand(`clear @a ${itemIdentifier2} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier2.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier2.split(":")[1]}"`);
    };
  };

  function lookForItem3(itemIdentifier3) {
    const data = runCommand(`clear @a ${itemIdentifier3} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier3.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier3.split(":")[1]}"`);
    };
  };

  function lookForItem4(itemIdentifier4) {
    const data = runCommand(`clear @a ${itemIdentifier4} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier4.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier4.split(":")[1]}"`);
    };
  };

  function lookForItem5(itemIdentifier5) {
    const data = runCommand(`clear @a ${itemIdentifier5} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier5.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier5.split(":")[1]}"`);
    };
  };
  
  function lookForItem6(itemIdentifier6) {
    const data = runCommand(`clear @a ${itemIdentifier6} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier6.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier6.split(":")[1]}"`);
    };
  };
  
  function lookForItem7(itemIdentifier7) {
    const data = runCommand(`clear @a ${itemIdentifier7} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier7.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier7.split(":")[1]}"`);
    };
  };
  
  function lookForItem8(itemIdentifier8) {
    const data = runCommand(`clear @a ${itemIdentifier8} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier8.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier8.split(":")[1]}"`);
    };
  };
  
  function lookForItem9(itemIdentifier9) {
    const data = runCommand(`clear @a ${itemIdentifier9} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier9.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier9.split(":")[1]}"`);
    };
  };
  
  function lookForItem10(itemIdentifier10) {
    const data = runCommand(`clear @a ${itemIdentifier10} -1 0`);
    let playersFound = [];
    if (!data.error) try {
      data.playerTest.forEach(element => {
        const itemCount = element.match(/(?<=.*?\().+?(?=\))/)[0];
        const player = element.match(/^.*(?= \(\d+\))/)[0];
        playersFound.push(player);
        if (parseInt(itemCount) > 0) {
          runCommand(`tag "${player}" add "has ${itemIdentifier10.split(":")[1]}"`);
        };
      });
    } catch (e) { };
    let playersWithNoItems = getPlayers().filter(currentPlayer => !playersFound.some(foundPlayer => currentPlayer === foundPlayer));
    for (const player of playersWithNoItems) {
      runCommand(`tag "${player}" remove "has ${itemIdentifier10.split(":")[1]}"`);
    };
  };

  lookForItem('js:oblivion_ammo');
  lookForItem2('js:svd_ammo');
  lookForItem3('js:fp6_ammo');
  lookForItem4('js:sh_plasma_cannon_ammo');
  lookForItem5('js:hk417_ammo');
  lookForItem6('js:flamethrower_ammo');
  lookForItem7('minecraft:diamond');
  lookForItem8('minecraft:lapis_block');
  lookForItem9('minecraft:netherite_ingot');
  lookForItem10('minecraft:diamond_block');
});